/*
**	LibPanel.c
**
**	Editing panel for transfer library configuration
**
**	Copyright  1990-1995 by Olaf `Olsen' Barthel
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_DEFAULT_TYPE=1000,
		GAD_DEFAULT_NAME,
		GAD_DEFAULT_SENDSIGNATURE,
		GAD_DEFAULT_PREFS,

		GAD_ASCII_UPLOAD_TYPE,
		GAD_ASCII_UPLOAD_NAME,
		GAD_ASCII_UPLOAD_SIGNATURE,
		GAD_ASCII_UPLOAD_PREFS,
		GAD_ASCII_DOWNLOAD_TYPE,
		GAD_ASCII_DOWNLOAD_NAME,
		GAD_ASCII_DOWNLOAD_SIGNATURE,
		GAD_ASCII_DOWNLOAD_PREFS,

		GAD_TEXT_UPLOAD_TYPE,
		GAD_TEXT_UPLOAD_NAME,
		GAD_TEXT_UPLOAD_SIGNATURE,
		GAD_TEXT_UPLOAD_PREFS,
		GAD_TEXT_DOWNLOAD_TYPE,
		GAD_TEXT_DOWNLOAD_NAME,
		GAD_TEXT_DOWNLOAD_SIGNATURE,
		GAD_TEXT_DOWNLOAD_PREFS,

		GAD_BINARY_UPLOAD_TYPE,
		GAD_BINARY_UPLOAD_NAME,
		GAD_BINARY_UPLOAD_SIGNATURE,
		GAD_BINARY_UPLOAD_PREFS,
		GAD_BINARY_DOWNLOAD_TYPE,
		GAD_BINARY_DOWNLOAD_NAME,
		GAD_BINARY_DOWNLOAD_SIGNATURE,
		GAD_BINARY_DOWNLOAD_PREFS,

		GAD_DEFAULT_RECEIVESIGNATURE,

		GAD_MANGLE,GAD_PAGE,GAD_PAGEGROUP,
		GAD_NOTIFY_AFTER_N_ERRORS,GAD_NOTIFY_WHEN,
		GAD_USE,GAD_CANCEL,GAD_DEFAULT,

		GAD_PROTOCOLTYPE
	};

BOOLEAN __regargs
SignaturePanel(struct Window *Parent,STRPTR String,BOOLEAN ReceiveMode)
{
	STATIC STRPTR SendProtocols[] =
	{
		"Z-Modem",
		NULL
	};

	STATIC STRPTR SendSignatureTypes[] =
	{
		"*^XB01",
		NULL
	};

	STATIC STRPTR ReceiveProtocols[] =
	{
		"Z-Modem",
		"Hydra",
		"QuickB",
		NULL
	};

	STATIC STRPTR ReceiveSignatureTypes[] =
	{
		"*^XB00",
		"^XcA\\\\f5\\\\a3^Xa",
		"\\*ENQ",
		NULL
	};

	struct LayoutHandle	*Handle;
	BOOLEAN			 Ok = FALSE;
	STRPTR			*SignatureTypes,
				*Protocols;

	if(ReceiveMode)
	{
		SignatureTypes	= ReceiveSignatureTypes;
		Protocols	= ReceiveProtocols;
	}
	else
	{
		SignatureTypes	= SendSignatureTypes;
		Protocols	= SendProtocols;
	}

	if(Handle = LT_CreateHandleTags(Parent -> WScreen,
		LH_LocaleHook,	&LocaleHook,
	TAG_DONE))
	{
		struct Window	*PanelWindow;
		BYTE		 Index = 0;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	LISTVIEW_KIND,
					LA_LabelID,	MSG_XFER_SELECT_SIGNATURE_TXT,
					LALV_Labels,	Protocols,
					LALV_Link,	NIL_LINK,
					LALV_CursorKey,	TRUE,
					LALV_MaxGrowY,	5,
					LA_BYTE,	&Index,
					LA_ID,		GAD_PROTOCOLTYPE,
					LA_Chars,	30,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Build(Handle,
			LAWN_TitleID,		MSG_XFER_SIGNATURE_TXT,
			LAWN_IDCMP,		IDCMP_CLOSEWINDOW,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;

			GuideContext(CONTEXT_SIGNATURE);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
					break;

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
						Done = TRUE;

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								strcpy(String,SignatureTypes[Index]);

								Ok = Done = TRUE;
								break;

							case GAD_CANCEL:

								Done = TRUE;
								break;
						}
					}

					if(MsgClass == IDCMP_IDCMPUPDATE)
					{
						strcpy(String,SignatureTypes[Index]);

						Ok = Done = TRUE;

						LT_PressButton(Handle,GAD_USE);
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	return(Ok);
}

BYTE __regargs
LibPanel(struct Configuration *Config,BYTE *Default)
{
	STATIC LONG PageTitleID[6] =
	{
		MSG_XFER_GENERAL_OPTIONS_TXT,
		MSG_XFER_PAGE1_TXT,
		MSG_XFER_PAGE2_TXT,
		MSG_XFER_PAGE3_TXT,
		MSG_XFER_PAGE4_TXT,
		-1
	};

	STATIC BYTE		 InitialPage = 0;

	struct LayoutHandle	*Handle;
	BYTE			 OpenIt = TRUE,
				 Cancel = FALSE;
	STRPTR			 Signatures[TRANSFERSIG_BINARYDOWNLOAD + 1];
	WORD			 i;
	STRPTR			 PageTitle[6];

	LocalizeStringTable(PageTitle,PageTitleID);

	if(!(Signatures[0] = AllocVecPooled(40 * (TRANSFERSIG_BINARYDOWNLOAD + 1),MEMF_ANY)))
		return(FALSE);

	SaveConfig(Config,PrivateConfig);

	for(i = 1 ; i <= TRANSFERSIG_BINARYDOWNLOAD ; i++)
		Signatures[i] = Signatures[i - 1] + 40;

	for(i = 0 ; i <= TRANSFERSIG_BINARYDOWNLOAD ; i++)
	{
		if(Config -> TransferConfig -> Signatures[i] . Length)
			TranslateBack(Config -> TransferConfig -> Signatures[i] . Signature,Config -> TransferConfig -> Signatures[i] . Length,Signatures[i]);
		else
			Signatures[i][0] = 0;
	}

	if(Handle = LT_CreateHandleTags(Window -> WScreen,
		LH_LocaleHook,	&LocaleHook,
		LH_ExitFlush,	FALSE,
	TAG_DONE))
	{
		struct Window *PanelWindow;

		LT_New(Handle,
			LA_Type,	VERTICAL_KIND,
		TAG_DONE);
		{
			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,		CYCLE_KIND,
					LA_LabelID,		MSG_XFER_PAGE_TXT,
					GTCY_Labels,		PageTitle,
					LACY_AutoPageID,	GAD_PAGEGROUP,
					LACY_TabKey,		TRUE,
					LA_BYTE,		&InitialPage,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,	VERTICAL_KIND,
				LA_ID,		GAD_PAGEGROUP,
				LAGR_Frame,	TRUE,
				LAGR_ActivePage,InitialPage,
			TAG_DONE);
			{

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	HORIZONTAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	VERTICAL_KIND,
						TAG_DONE);
						{
							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MISCPANEL_OVERRIDE_TRANSFER_PATH_GAD,
								LA_BYTE,	&Config -> TransferConfig -> OverridePath,
							TAG_DONE);

							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MISCPANEL_SET_ARCHIVED_BIT_GAD,
								LA_BYTE,	&Config -> TransferConfig -> SetArchivedBit,
							TAG_DONE);

							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MISCPANEL_TRANSFER_ICONS_GAD,
								LA_BYTE,	&Config -> TransferConfig -> TransferIcons,
							TAG_DONE);

							LT_EndGroup(Handle);
						}

						LT_New(Handle,
							LA_Type,	VERTICAL_KIND,
						TAG_DONE);
						{
							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MANGLE_UPLOAD_FILENAMES_TXT,
								LA_BYTE,	&Config -> TransferConfig -> MangleFileNames,
								LA_ID,		GAD_MANGLE,
							TAG_DONE);

							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MISCPANEL_TRANSFER_METER_GAD,
								LA_BYTE,	&Config -> TransferConfig -> PerfMeter,
							TAG_DONE);

							LT_New(Handle,
								LA_Type,	CHECKBOX_KIND,
								LA_LabelID,	MSG_MISCPANEL_HIDE_UPLOAD_ICON_GAD,
								LA_BYTE,	&Config -> TransferConfig -> HideUploadIcon,
							TAG_DONE);

							LT_EndGroup(Handle);
						}

						LT_EndGroup(Handle);
					}

					LT_New(Handle,
						LA_Type,	VERTICAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,	XBAR_KIND,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,		INTEGER_KIND,
							LA_LabelID,		MSG_NOTIFY_USER_AFTER_N_ERRORS_HAVE_OCCURED_TXT,
							LA_UWORD,		&Config -> TransferConfig -> ErrorNotification,
							LA_ID,			GAD_NOTIFY_AFTER_N_ERRORS,
							LA_Chars,		8,
							LAIN_Min,		0,
							LAIN_Max,		65535,
							LAIN_UseIncrementers,	TRUE,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_New(Handle,
						LA_Type,	VERTICAL_KIND,
					TAG_DONE);
					{
						LT_New(Handle,
							LA_Type,		CYCLE_KIND,
							LA_LabelID,		MSG_NOTIFY_USER_TXT,
							LA_BYTE,		&Config -> TransferConfig -> TransferNotification,
							LA_ID,			GAD_NOTIFY_WHEN,
							LACY_FirstLabel,	MSG_NOTIFY_USER_MODE1_TXT,
							LACY_LastLabel,		MSG_NOTIFY_USER_MODE4_TXT,
						TAG_DONE);

						LT_New(Handle,
							LA_Type,		CYCLE_KIND,
							LA_LabelID,		MSG_MISCPANEL_IDENTIFY_FILES_GAD,
							LACY_FirstLabel,	MSG_MISCPANEL_IDENTIFY_IGNORE_TXT,
							LACY_LastLabel,		MSG_MISCPANEL_IDENTIFY_SOURCE_TXT,
							LA_BYTE,		&Config -> TransferConfig -> IdentifyFiles,
						TAG_DONE);

						LT_EndGroup(Handle);
					}

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_DEFAULT_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> DefaultType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE2_TXT,
						LA_Chars,	40,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_DEFAULT_NAME,
						LA_LabelID,	MSG_XFER_NAME_TXT,
						LA_STRPTR,	Config -> TransferConfig -> DefaultLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_DEFAULT_SENDSIGNATURE,
						LA_LabelID,	MSG_XFER_SEND_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_DEFAULTUPLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_DEFAULT_RECEIVESIGNATURE,
						LA_LabelID,	MSG_XFER_RECEIVE_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_DEFAULTDOWNLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_DEFAULT_PREFS,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_ASCII_UPLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> ASCIIUploadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE4_TXT,
						LA_Chars,	40,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_ASCII_UPLOAD_NAME,
						LA_LabelID,	MSG_XFER_SEND_TXT,
						LA_STRPTR,	Config -> TransferConfig -> ASCIIUploadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> ASCIIUploadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIUploadType == XFER_INTERNAL,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_ASCII_UPLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_ASCIIUPLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> ASCIIUploadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIUploadType == XFER_INTERNAL,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_ASCII_UPLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> ASCIIUploadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIUploadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	XBAR_KIND,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_ASCII_DOWNLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> ASCIIDownloadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE4_TXT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_ASCII_DOWNLOAD_NAME,
						LA_LabelID,	MSG_XFER_RECEIVE_TXT,
						LA_STRPTR,	Config -> TransferConfig -> ASCIIDownloadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> ASCIIDownloadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIDownloadType == XFER_INTERNAL,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_ASCII_DOWNLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_ASCIIDOWNLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> ASCIIDownloadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIDownloadType == XFER_INTERNAL,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_ASCII_DOWNLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> ASCIIDownloadType == XFER_DEFAULT || Config -> TransferConfig -> ASCIIDownloadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_TEXT_UPLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> TextUploadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE3_TXT,
						LA_Chars,	40,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_TEXT_UPLOAD_NAME,
						LA_LabelID,	MSG_XFER_SEND_TXT,
						LA_STRPTR,	Config -> TransferConfig -> TextUploadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> TextUploadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_TEXT_UPLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_TEXTUPLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> TextUploadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_TEXT_UPLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> TextUploadType == XFER_DEFAULT || Config -> TransferConfig -> TextUploadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	XBAR_KIND,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_TEXT_DOWNLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> TextDownloadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE3_TXT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_TEXT_DOWNLOAD_NAME,
						LA_LabelID,	MSG_XFER_RECEIVE_TXT,
						LA_STRPTR,	Config -> TransferConfig -> TextDownloadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> TextDownloadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_TEXT_DOWNLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_TEXTDOWNLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> TextDownloadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_TEXT_DOWNLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> TextDownloadType == XFER_DEFAULT || Config -> TransferConfig -> TextDownloadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_New(Handle,
					LA_Type,	VERTICAL_KIND,
				TAG_DONE);
				{
					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_BINARY_UPLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> BinaryUploadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE3_TXT,
						LA_Chars,	40,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_BINARY_UPLOAD_NAME,
						LA_LabelID,	MSG_XFER_SEND_TXT,
						LA_STRPTR,	Config -> TransferConfig -> BinaryUploadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> BinaryUploadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_BINARY_UPLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_BINARYUPLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> BinaryUploadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_BINARY_UPLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> BinaryUploadType == XFER_DEFAULT || Config -> TransferConfig -> BinaryUploadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	XBAR_KIND,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	CYCLE_KIND,
						LA_ID,		GAD_BINARY_DOWNLOAD_TYPE,
						LA_BYTE,	&Config -> TransferConfig -> BinaryDownloadType,
						LA_LabelID,	MSG_XFER_TYPE_TXT,
						LACY_FirstLabel,MSG_XFER_TYPE1_TXT,
						LACY_LastLabel,	MSG_XFER_TYPE3_TXT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_BINARY_DOWNLOAD_NAME,
						LA_LabelID,	MSG_XFER_RECEIVE_TXT,
						LA_STRPTR,	Config -> TransferConfig -> BinaryDownloadLibrary,
						GTST_MaxChars,	MAX_FILENAME_LENGTH,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> BinaryDownloadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	STRING_KIND,
						LA_ID,		GAD_BINARY_DOWNLOAD_SIGNATURE,
						LA_LabelID,	MSG_XFER_SIGNATURE_TXT,
						LA_STRPTR,	Signatures[TRANSFERSIG_BINARYDOWNLOAD],
						GTST_MaxChars,	40,
						LAST_Picker,	TRUE,
						GA_Disabled,	Config -> TransferConfig -> BinaryDownloadType == XFER_DEFAULT,
					TAG_DONE);

					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_XFER_SETTINGS_TXT,
						LA_ID,		GAD_BINARY_DOWNLOAD_PREFS,
						GA_Disabled,	Config -> TransferConfig -> BinaryDownloadType == XFER_DEFAULT || Config -> TransferConfig -> BinaryDownloadType == XFER_EXTERNALPROGRAM,
					TAG_DONE);

					LT_EndGroup(Handle);
				}

				LT_EndGroup(Handle);
			}

			LT_New(Handle,
				LA_Type,VERTICAL_KIND,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	XBAR_KIND,
					LAXB_FullSize,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_New(Handle,LA_Type,HORIZONTAL_KIND,
				LAGR_SameSize,	TRUE,
				LAGR_Spread,	TRUE,
			TAG_DONE);
			{
				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_USE_GAD,
					LA_ID,		GAD_USE,
					LABT_ReturnKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				if(Default)
				{
					LT_New(Handle,
						LA_Type,	BUTTON_KIND,
						LA_LabelID,	MSG_GLOBAL_DEFAULT_GAD,
						LA_ID,		GAD_DEFAULT,
						LABT_ExtraFat,	TRUE,
					TAG_DONE);
				}

				LT_New(Handle,
					LA_Type,	BUTTON_KIND,
					LA_LabelID,	MSG_GLOBAL_CANCEL_GAD,
					LA_ID,		GAD_CANCEL,
					LABT_EscKey,	TRUE,
					LABT_ExtraFat,	TRUE,
				TAG_DONE);

				LT_EndGroup(Handle);
			}

			LT_EndGroup(Handle);
		}

		if(PanelWindow = LT_Layout(Handle,LocaleString(MSG_LIBPANEL_LIBRARY_PREFERENCES_TXT),NULL,0,0,IDCMP_CLOSEWINDOW,0,
			LAWN_HelpHook,		&GuideHook,
			LAWN_Parent,		Window,
			WA_DepthGadget,		TRUE,
			WA_CloseGadget,		TRUE,
			WA_DragBar,		TRUE,
			WA_RMBTrap,		TRUE,
			WA_Activate,		TRUE,
		TAG_DONE))
		{
			struct IntuiMessage	*Message;
			BOOLEAN			 Done = FALSE;
			ULONG			 MsgClass,
						 MsgQualifier;
			UWORD			 MsgCode;
			struct Gadget		*MsgGadget;
			WORD			 Type;
			STRPTR			 Contents;

			GuideContext(CONTEXT_LIBS);

			PushWindow(PanelWindow);

			LT_ShowWindow(Handle,TRUE);

			do
			{
				if(Wait(PORTMASK(PanelWindow -> UserPort) | SIG_BREAK) & SIG_BREAK)
				{
					SaveConfig(PrivateConfig,Config);

					Cancel = TRUE;

					break;
				}

				while(Message = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort))
				{
					MsgClass	= Message -> Class;
					MsgQualifier	= Message -> Qualifier;
					MsgCode		= Message -> Code;
					MsgGadget	= (struct Gadget *)Message -> IAddress;

					GT_ReplyIMsg(Message);

					LT_HandleInput(Handle,MsgQualifier,&MsgClass,&MsgCode,&MsgGadget);

					if(MsgClass == IDCMP_CLOSEWINDOW)
					{
						SaveConfig(PrivateConfig,Config);

						Cancel = Done = TRUE;
					}

					if(MsgClass == IDCMP_GADGETUP)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_USE:

								LT_UpdateStrings(Handle);

								for(i = 0 ; i <= TRANSFERSIG_BINARYDOWNLOAD ; i++)
									Config -> TransferConfig -> Signatures[i] . Length = TranslateString(Signatures[i],Config -> TransferConfig -> Signatures[i] . Signature);

								Done = TRUE;
								break;

							case GAD_CANCEL:

								SaveConfig(PrivateConfig,Config);

								Cancel = Done = TRUE;

								OpenIt = FALSE;

								break;

							case GAD_DEFAULT:

								*Default = TRUE;

								Done = TRUE;

								OpenIt = FALSE;

								break;

							case GAD_DEFAULT_NAME:
							case GAD_ASCII_UPLOAD_NAME:
							case GAD_ASCII_DOWNLOAD_NAME:
							case GAD_TEXT_UPLOAD_NAME:
							case GAD_TEXT_DOWNLOAD_NAME:
							case GAD_BINARY_UPLOAD_NAME:
							case GAD_BINARY_DOWNLOAD_NAME:

								switch(LT_GetAttributes(Handle,MsgGadget -> GadgetID - 1,TAG_DONE))
								{
									case XFER_XPR:

										FindLibDev(PanelWindow,LT_GetString(Handle,MsgGadget -> GadgetID),NT_LIBRARY,NULL);

										break;

									case XFER_EXTERNALPROGRAM:

										FindProgram(PanelWindow,LT_GetString(Handle,MsgGadget -> GadgetID),NULL);

										break;
								}

								break;

							case GAD_DEFAULT_TYPE:
							case GAD_ASCII_UPLOAD_TYPE:
							case GAD_ASCII_DOWNLOAD_TYPE:
							case GAD_TEXT_UPLOAD_TYPE:
							case GAD_TEXT_DOWNLOAD_TYPE:
							case GAD_BINARY_UPLOAD_TYPE:
							case GAD_BINARY_DOWNLOAD_TYPE:

								LT_SetAttributes(Handle,MsgGadget -> GadgetID + 1,
									GA_Disabled,	MsgCode == XFER_DEFAULT || MsgCode == XFER_INTERNAL,
								TAG_DONE);

								LT_SetAttributes(Handle,MsgGadget -> GadgetID + 2,
									GA_Disabled,	MsgCode == XFER_DEFAULT || MsgCode == XFER_INTERNAL,
								TAG_DONE);

								LT_SetAttributes(Handle,MsgGadget -> GadgetID + 3,
									GA_Disabled,	MsgCode == XFER_DEFAULT || MsgCode == XFER_EXTERNALPROGRAM,
								TAG_DONE);

								break;

							case GAD_DEFAULT_PREFS:
							case GAD_ASCII_UPLOAD_PREFS:
							case GAD_ASCII_DOWNLOAD_PREFS:
							case GAD_TEXT_UPLOAD_PREFS:
							case GAD_TEXT_DOWNLOAD_PREFS:
							case GAD_BINARY_UPLOAD_PREFS:
							case GAD_BINARY_DOWNLOAD_PREFS:

								Type		= LT_GetAttributes(Handle,MsgGadget -> GadgetID - 3,TAG_DONE);
								Contents	= LT_GetString(Handle,MsgGadget -> GadgetID - 2);

								if(Type == XFER_XPR)
								{
									if(Contents[0])
									{
										LT_LockWindow(PanelWindow);

										if(ChangeProtocol(Contents,Type))
										{
											if(XProtocolBase)
											{
												XprIO -> xpr_filename = NULL;

												XPRCommandSelected = FALSE;

												ClearSerial();

												NewOptions = FALSE;

												TransferBits = XProtocolSetup(XprIO);

												RestartSerial(FALSE);

												DeleteTransferPanel(TRUE);

													/* Successful? */

												if(!(TransferBits & XPRS_SUCCESS))
												{
													MyEasyRequest(PanelWindow,LocaleString(MSG_GLOBAL_FAILED_TO_SET_UP_PROTOCOL_TXT),LocaleString(MSG_GLOBAL_CONTINUE_TXT),LastXprLibrary);

													CloseLibrary(XProtocolBase);

													XProtocolBase = NULL;

													LastXprLibrary[0] = 0;

													TransferBits = 0;

													SetTransferMenu(FALSE);
												}
												else
													SaveProtocolOpts();
											}
										}

										ResetProtocol();

										LT_UnlockWindow(PanelWindow);
									}
								}

								if(Type == XFER_INTERNAL)
								{
									LT_LockWindow(PanelWindow);

									ASCIITransferPanel(PanelWindow,Config);

									LT_UnlockWindow(PanelWindow);

									LT_ShowWindow(Handle,TRUE);
								}

								break;
						}
					}

					if(MsgClass == IDCMP_IDCMPUPDATE)
					{
						switch(MsgGadget -> GadgetID)
						{
							case GAD_DEFAULT_SENDSIGNATURE:
							case GAD_ASCII_UPLOAD_SIGNATURE:
							case GAD_TEXT_UPLOAD_SIGNATURE:
							case GAD_BINARY_UPLOAD_SIGNATURE:

								LT_LockWindow(PanelWindow);

								if(SignaturePanel(PanelWindow,SharedBuffer,FALSE))
									LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,SharedBuffer,TAG_DONE);

								LT_UnlockWindow(PanelWindow);

								LT_ShowWindow(Handle,TRUE);
								break;

							case GAD_DEFAULT_RECEIVESIGNATURE:
							case GAD_ASCII_DOWNLOAD_SIGNATURE:
							case GAD_TEXT_DOWNLOAD_SIGNATURE:
							case GAD_BINARY_DOWNLOAD_SIGNATURE:

								LT_LockWindow(PanelWindow);

								if(SignaturePanel(PanelWindow,SharedBuffer,TRUE))
									LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,SharedBuffer,TAG_DONE);

								LT_UnlockWindow(PanelWindow);

								LT_ShowWindow(Handle,TRUE);
								break;

							default:

								Type = LT_GetAttributes(Handle,MsgGadget -> GadgetID - 1,TAG_DONE);

								if(Type == XFER_XPR)
								{
									LT_LockWindow(PanelWindow);

									strcpy(SharedBuffer,(STRPTR)LT_GetAttributes(Handle,MsgGadget -> GadgetID,TAG_DONE));

									if(PickFile(PanelWindow,"Libs:","xpr#?.library",LocaleString(MSG_LIBPANEL_SELECT_DEFAULT_TRANSFER_LIBRARY_TXT + (MsgGadget -> GadgetID - GAD_DEFAULT_TYPE) / 4),SharedBuffer,NT_LIBRARY))
									{
										FindLibDev(PanelWindow,SharedBuffer,NT_LIBRARY,NULL);

										LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,SharedBuffer,TAG_DONE);
									}

									LT_UnlockWindow(PanelWindow);

									LT_ShowWindow(Handle,TRUE);
								}

								if(Type == XFER_EXTERNALPROGRAM)
								{
									LT_LockWindow(PanelWindow);

									Contents = LT_GetString(Handle,MsgGadget -> GadgetID);

									if(ExternalCommandPanel(PanelWindow,Contents))
									{
										FindProgram(PanelWindow,Contents,NULL);

										LT_SetAttributes(Handle,MsgGadget -> GadgetID,GTST_String,Contents,TAG_DONE);
									}

									LT_UnlockWindow(PanelWindow);

									LT_ShowWindow(Handle,TRUE);
								}

								break;
						}
					}
				}
			}
			while(!Done);

			PopWindow();
		}

		LT_DeleteHandle(Handle);
	}

	FreeVecPooled(Signatures[0]);

	if(Default)
		return((BYTE)(!Cancel));
	else
	{
		if(Cancel)
			return(FALSE);

		if(Config -> PathConfig && Config -> TransferConfig && Config -> MiscConfig)
		{
			if(Config -> MiscConfig -> ProtectiveMode && !Config -> TransferConfig -> OverridePath)
			{
				STRPTR	Library	= NULL,
					Path	= NULL;

				if(Config -> TransferConfig -> DefaultType == XFER_XPR && Config -> TransferConfig -> DefaultLibrary[0])
				{
					Library	= Config -> TransferConfig -> DefaultLibrary;
					Path	= Config -> PathConfig -> BinaryDownloadPath;
				}

				if(Config -> TransferConfig -> ASCIIDownloadType == XFER_XPR && Config -> TransferConfig -> ASCIIDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> ASCIIDownloadLibrary;
					Path	= Config -> PathConfig -> ASCIIDownloadPath;
				}

				if(Config -> TransferConfig -> TextDownloadType == XFER_XPR && Config -> TransferConfig -> TextDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> TextDownloadLibrary;
					Path	= Config -> PathConfig -> TextDownloadPath;
				}

				if(Config -> TransferConfig -> BinaryDownloadType == XFER_XPR && Config -> TransferConfig -> BinaryDownloadLibrary[0])
				{
					Library	= Config -> TransferConfig -> BinaryDownloadLibrary;
					Path	= Config -> PathConfig -> BinaryDownloadPath;
				}

				if(Library && Path)
				{
					UBYTE LocalBuffer[MAX_FILENAME_LENGTH];

					if(*Path == 0)
					{
						if(GetCurrentDirName(LocalBuffer,MAX_FILENAME_LENGTH))
							Path = LocalBuffer;
					}

					if(MyEasyRequest(Window,LocaleString(MSG_XPR_PATH_TXT),LocaleString(MSG_GLOBAL_YES_NO_TXT),Library,Path))
						Config -> TransferConfig -> OverridePath = TRUE;
				}
			}
		}

		if(XProtocolBase)
			return((BYTE)memcmp(PrivateConfig -> TransferConfig,Config -> TransferConfig,sizeof(struct TransferSettings)));
		else
		{
			if(Config -> TransferConfig -> DefaultLibrary[0])
				return(OpenIt);
			else
				return((BYTE)memcmp(PrivateConfig -> TransferConfig,Config -> TransferConfig,sizeof(struct TransferSettings)));
		}
	}
}
